﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using AsynchronousWPFApplication.Models;

namespace AsynchronousWPFApplication
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        MyViewModel _model;

        /// <summary>
        /// Initialization
        /// Instanciation of our Data Model
        /// </summary>
        public MainWindow()
        {
            InitializeComponent();
            _model = new MyViewModel();
            _model.PropertyChanged += new System.ComponentModel.PropertyChangedEventHandler(_model_PropertyChanged);
        }

        #region Controls
        private void CleanTheGridBtn_Click(object sender, RoutedEventArgs e)
        {
            dataGrid1.DataContext = null;
        }

        private void Refresh_Click(object sender, RoutedEventArgs e)
        {
            _model.LoadPeople();
        }
        #endregion


        #region Model Interactions
        void _model_PropertyChanged(object sender, System.ComponentModel.PropertyChangedEventArgs e)
        {
            switch (e.PropertyName)
            {
                case "IsBusy":
                    if (_model.IsBusy)
                    {
                        //Display ProgressBar
                        backgroundMask.Visibility = System.Windows.Visibility.Visible;
                    }
                    else
                    {
                        //Hide ProgressBar and fill the grid
                        backgroundMask.Visibility = System.Windows.Visibility.Hidden;
                        dataGrid1.DataContext = _model.Peoples;
                    }
                    
                    break;

                case "LoadingPercentage":
                    loadingProgressBar.Value = _model.LoadingPercentage;
                    loadingSetp.Content = _model.LoadingStep;
                    break;
            }
        }
        #endregion

    }
}
